<?xml version="1.0" encoding="utf-8"?>

<!--
  Copyright (C) 2017 The Android Open Source Project

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
  -->

<manifest xmlns:android="http://schemas.android.com/apk/res/android"
          package="com.android.car.settings"
          coreApp="true"
          android:sharedUserId="android.uid.system"
          android:versionCode="1"
          android:versionName="1.0">

    <uses-sdk
        android:minSdkVersion="24"
        android:targetSdkVersion="33"/>

    <uses-permission android:name="android.permission.ACCESS_WIFI_STATE"/>
    <uses-permission android:name="android.permission.ACCESS_NETWORK_STATE"/>
    <uses-permission android:name="android.permission.BACKUP"/>
    <!-- Request legacy Bluetooth permissions on older devices. -->
    <uses-permission android:name="android.permission.BLUETOOTH"
                     android:maxSdkVersion="30" />
    <uses-permission android:name="android.permission.BLUETOOTH_ADMIN"
                     android:maxSdkVersion="30" />
    <uses-permission android:name="android.permission.BLUETOOTH_SCAN" />
    <uses-permission android:name="android.permission.BLUETOOTH_ADVERTISE" />
    <uses-permission android:name="android.permission.BLUETOOTH_CONNECT" />
    <uses-permission android:name="android.permission.BLUETOOTH_PRIVILEGED"/>
    <uses-permission android:name="android.permission.CAR_VENDOR_EXTENSION"/>
    <uses-permission android:name="android.permission.CHANGE_WIFI_STATE"/>
    <uses-permission android:name="android.permission.CLEAR_APP_USER_DATA"/>
    <uses-permission android:name="android.permission.CONTROL_DISPLAY_UNITS"/>
    <uses-permission android:name="android.permission.DELETE_CACHE_FILES"/>
    <uses-permission android:name="android.permission.DUMP"/>
    <uses-permission android:name="android.permission.FORCE_STOP_PACKAGES"/>
    <uses-permission android:name="android.permission.GET_ACCOUNTS_PRIVILEGED"/>
    <uses-permission android:name="android.permission.GET_PACKAGE_SIZE"/>
    <uses-permission android:name="android.permission.HIDE_NON_SYSTEM_OVERLAY_WINDOWS"/>
    <uses-permission android:name="android.permission.INJECT_EVENTS"/>
    <uses-permission android:name="android.permission.INTERNET"/>
    <uses-permission android:name="android.permission.MANAGE_ACCOUNTS"/>
    <uses-permission android:name="android.permission.MANAGE_SENSOR_PRIVACY"/>
    <uses-permission android:name="android.permission.MANAGE_USERS"/>
    <uses-permission android:name="android.permission.MASTER_CLEAR" />
    <uses-permission android:name="android.permission.MOUNT_UNMOUNT_FILESYSTEMS"/>
    <uses-permission android:name="android.permission.NETWORK_SETTINGS" />
    <uses-permission android:name="android.permission.OBSERVE_SENSOR_PRIVACY"/>
    <uses-permission android:name="android.permission.OVERRIDE_WIFI_CONFIG"/>
    <uses-permission android:name="android.permission.READ_CONTACTS"/>
    <uses-permission android:name="android.permission.READ_DEVICE_CONFIG" />
    <uses-permission android:name="android.permission.READ_DISPLAY_UNITS"/>
    <uses-permission android:name="android.permission.REBOOT"/>
    <uses-permission android:name="android.permission.READ_EXTERNAL_STORAGE"/>
    <uses-permission android:name="android.permission.RECEIVE_BOOT_COMPLETED"/>
    <uses-permission android:name="android.permission.REQUEST_DELETE_PACKAGES"/>
    <uses-permission android:name="android.permission.SET_PREFERRED_APPLICATIONS"/>
    <uses-permission android:name="android.permission.START_FOREGROUND"/>
    <uses-permission android:name="android.permission.START_VIEW_APP_FEATURES" />
    <uses-permission android:name="android.permission.STATUS_BAR_SERVICE"/>
    <uses-permission android:name="android.permission.SUGGEST_MANUAL_TIME_AND_ZONE"/>
    <uses-permission android:name="android.permission.UWB_PRIVILEGED"/>
    <uses-permission android:name="android.permission.WRITE_SETTINGS"/>
    <uses-permission android:name="android.permission.WRITE_SECURE_SETTINGS"/>
    <uses-permission android:name="android.car.permission.CAR_CONTROL_AUDIO_SETTINGS"/>
    <uses-permission android:name="android.car.permission.CAR_CONTROL_AUDIO_VOLUME"/>
    <uses-permission android:name="android.car.permission.READ_PERSIST_TETHERING_SETTINGS"/>

    <permission android:name="com.android.car.settings.SET_INITIAL_LOCK"
        android:protectionLevel="signature|setup"/>

    <application
        android:name=".CarSettingsApplication"
        android:icon="@drawable/ic_launcher_settings"
        android:theme="@style/CarSettingTheme"
        android:label="@string/settings_label"
        android:requiredForAllUsers="true"
        android:directBootAware="true"
        android:supportsRtl="true">

        <activity android:name=".admin.FactoryResetActivity"
            android:excludeFromRecents="true"
            android:theme="@android:style/Theme.NoTitleBar.Fullscreen"
            android:exported="false"
            android:launchMode="singleTask">
        </activity>
        <activity android:name=".admin.NewUserDisclaimerActivity"
            android:excludeFromRecents="true"
            android:theme="@style/ActionDialogTheme"
            android:exported="false"
            android:launchMode="singleTask">
        </activity>

        <activity
            android:name=".common.CarSettingActivities$HomepageActivity"
            android:launchMode="singleTask"
            android:finishOnTaskLaunch="true"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="1">
                <action android:name="android.settings.SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_HomepageActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.SubSettingsActivity"
            android:windowSoftInputMode="adjustPan">
            <meta-data android:name="com.android.car.settings.SINGLE_PANE" android:value="true"/>
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$DisplaySettingsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="1">
                <action android:name="android.settings.DISPLAY_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_DisplaySettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$SoundSettingsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="1">
                <action android:name="android.settings.SOUND_SETTINGS" />
                <action android:name="android.settings.panel.action.VOLUME" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_SoundSettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$RingtonePickerActivity"
            android:windowSoftInputMode="adjustPan"
            android:finishOnTaskLaunch="true"
            android:exported="true">
            <intent-filter android:priority="1">
                <action android:name="android.intent.action.RINGTONE_PICKER" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_RingtonePickerActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$NetworkAndInternetActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="android.settings.panel.action.INTERNET_CONNECTIVITY" />
                <action android:name="android.settings.WIRELESS_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_NetworkAndInternetActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$BluetoothSettingsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="1">
                <action android:name="android.settings.BLUETOOTH_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_BluetoothSettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$UnitsSettingsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_UnitsSettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$LocationSettingsActivity"
            android:configChanges="orientation|keyboardHidden|screenSize"
            android:windowSoftInputMode="adjustResize"
            android:exported="true">
            <intent-filter>
                <action android:name="android.settings.LOCATION_SOURCE_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_LocationSettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$AppsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter>
                <action android:name="android.settings.APPLICATION_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_AppsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$NotificationsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter>
                <action android:name="android.settings.NOTIFICATION_SETTINGS" />
                <action android:name="android.settings.ALL_APPS_NOTIFICATION_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_NotificationsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$DatetimeSettingsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="1">
                <action android:name="android.settings.DATE_SETTINGS" />
                <action android:name="android.intent.action.QUICK_CLOCK" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_DatetimeSettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$ProfileDetailsActivity"
            android:excludeFromRecents="true"
            android:exported="true">
            <intent-filter android:priority="1">
                <action android:name="android.settings.USER_SETTINGS" />
                <action android:name="android.settings.SYNC_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_ProfileDetailsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$PrivacySettingsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="android.settings.PRIVACY_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_PrivacySettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$VehicleDataActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_VehicleDataActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$StorageSettingsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="android.settings.INTERNAL_STORAGE_SETTINGS" />
                <action android:name="android.os.storage.action.MANAGE_STORAGE" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_StorageSettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$SecuritySettingsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="android.settings.SECURITY_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_SecuritySettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$AssistantAndVoiceSettingsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter>
                <action android:name="android.settings.VOICE_INPUT_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_AssistantAndVoiceSettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$SystemSettingsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_SystemSettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$WifiSettingsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="android.net.wifi.PICK_WIFI_NETWORK" />
                <action android:name="android.settings.WIFI_SETTINGS" />
                <action android:name="android.settings.panel.action.WIFI" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_WifiSettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$WifiTetherActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="com.android.settings.WIFI_TETHER_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_WifiTetherActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$MobileNetworkActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="android.settings.DATA_ROAMING_SETTINGS" />
                <action android:name="android.settings.NETWORK_OPERATOR_SETTINGS" />
                <action android:name="android.settings.DATA_USAGE_SETTINGS" />
                <action android:name="android.settings.MOBILE_DATA_USAGE" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_MobileNetworkActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$MobileNetworkListActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_MobileNetworkListActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$ApplicationsSettingsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="1">
                <action android:name="android.settings.MANAGE_APPLICATIONS_SETTINGS" />
                <action android:name="android.settings.MANAGE_ALL_APPLICATIONS_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_ApplicationsSettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$SpecialAccessSettingsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_SpecialAccessSettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$LanguagesAndInputActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_LanguagesAndInputActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$AboutSettingsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="android.settings.DEVICE_INFO_SETTINGS" />
                <action android:name="android.settings.DEVICE_NAME" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_AboutSettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$LegalInformationActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_LegalInformationActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$ResetOptionsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_ResetOptionsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$AddWifiActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="android.settings.WIFI_ADD_NETWORKS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_AddWifiActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$WifiPreferencesActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="android.settings.WIFI_IP_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_WifiPreferencesActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$ApplicationsDetailsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <!-- The following intent actions are listed twice in order to support multiple ways to
                provide the package name. -->
            <!-- This intent filter expects to receive the package name via the data field.
                 i.e. adb shell am start -a android.settings.APPLICATION_DETAILS_SETTINGS \
                      -d "package:<package name>" -->
            <intent-filter android:priority="100">
                <action android:name="android.settings.APPLICATION_DETAILS_SETTINGS" />
                <action android:name="android.settings.CHANNEL_NOTIFICATION_SETTINGS" />
                <action android:name="android.settings.APP_NOTIFICATION_SETTINGS" />
                <action android:name="android.intent.action.AUTO_REVOKE_PERMISSIONS" />
                <data android:scheme="package" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>

            <!-- This intent filter expects to receive the package name via an extra string.
                 i.e. adb shell am start -a android.settings.APPLICATION_DETAILS_SETTINGS
                      -e "android.provider.extra.APP_PACKAGE" "<package name>" -->
            <intent-filter android:priority="100">
                <action android:name="android.settings.APPLICATION_DETAILS_SETTINGS" />
                <action android:name="android.settings.CHANNEL_NOTIFICATION_SETTINGS" />
                <action android:name="android.settings.APP_NOTIFICATION_SETTINGS" />
                <action android:name="android.intent.action.AUTO_REVOKE_PERMISSIONS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_ApplicationsDetailsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$ModifySystemSettingsActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="android.settings.action.MANAGE_WRITE_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_ModifySystemSettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$NotificationAccessActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="android.settings.ACTION_NOTIFICATION_LISTENER_SETTINGS" />
                <action android:name="android.settings.NOTIFICATION_LISTENER_DETAIL_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_NotificationAccessActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$PremiumSmsAccessActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_PremiumSmsAccessActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$UsageAccessActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="android.settings.USAGE_ACCESS_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_UsageAccessActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$WifiControlActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_WifiControlActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$ChooseAccountActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="android.settings.ADD_ACCOUNT_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_ChooseAccountActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$LanguagePickerActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="android.settings.LOCALE_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_LanguagePickerActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$DefaultAutofillPickerActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="android.settings.REQUEST_SET_AUTOFILL_SERVICE" />
                <category android:name="android.intent.category.DEFAULT" />
                <data android:scheme="package" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_DefaultAutofillPickerActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$KeyboardActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="100">
                <action android:name="android.settings.INPUT_METHOD_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_KeyboardActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$TextToSpeechOutputActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="1">
                <action android:name="com.android.settings.TTS_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_TextToSpeechOutputActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$AlarmsAndRemindersActivity"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter android:priority="1">
                <action android:name="android.settings.REQUEST_SCHEDULE_EXACT_ALARM" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <intent-filter android:priority="1">
                <action android:name="android.settings.REQUEST_SCHEDULE_EXACT_ALARM" />
                <category android:name="android.intent.category.DEFAULT" />
                <data android:scheme="package" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_AlarmsAndRemindersActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <!-- Aliases for launcher activity only, as this belongs to each profile. -->
        <activity-alias
            android:name="Settings_Launcher_Homepage"
            android:label="@string/settings_label"
            android:launchMode="singleTask"
            android:exported="true"
            android:finishOnTaskLaunch="true"
            android:targetActivity=".common.CarSettingActivities$HomepageActivity"
            android:enabled="@bool/config_enable_home_settings_icon">
            <intent-filter android:priority="1">
                <action android:name="android.intent.action.MAIN" />
                <category android:name="android.intent.category.DEFAULT" />
                <category android:name="android.intent.category.LAUNCHER" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_HomepageActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity-alias>

        <activity android:name=".enterprise.RemoteRequestBugreportActivity"
            android:excludeFromRecents="true"
            android:exported="true"
            android:permission="android.permission.DUMP">
            <intent-filter>
                <action android:name="android.settings.SHOW_REMOTE_BUGREPORT_DIALOG" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

        <activity
            android:name=".bluetooth.BluetoothPairingDialog"
            android:permission="android.permission.BLUETOOTH_PRIVILEGED"
            android:excludeFromRecents="true"
            android:windowSoftInputMode="stateVisible|adjustResize"
            android:taskAffinity="car.settings.bluetooth"
            android:launchMode="singleTask"
            android:theme="@style/ActionDialogTheme">
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".bluetooth.BluetoothDevicePickerActivity"
            android:label="@string/bluetooth_device_picker"
            android:configChanges="orientation|keyboardHidden|screenSize"
            android:exported="true"
            android:clearTaskOnLaunch="true">
            <intent-filter>
                <action android:name="android.bluetooth.devicepicker.action.LAUNCH" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_BluetoothDevicePickerActivity" />
        </activity>

        <activity
            android:name=".bluetooth.BluetoothRequestPermissionActivity"
            android:theme="@style/ActionDialogTheme"
            android:excludeFromRecents="true"
            android:clearTaskOnLaunch="true"
            android:exported="true"
            android:launchMode="singleInstance"
            android:permission="android.permission.BLUETOOTH_CONNECT">
            <intent-filter>
                <action android:name="android.bluetooth.adapter.action.REQUEST_DISCOVERABLE" />
                <action android:name="android.bluetooth.adapter.action.REQUEST_ENABLE" />
                <action android:name="android.bluetooth.adapter.action.REQUEST_DISABLE" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

        <activity
            android:name=".accounts.AddAccountActivity"
            android:theme="@android:style/Theme.Translucent.NoTitleBar"
            android:configChanges="orientation|keyboardHidden|screenSize"
            android:exported="true"/>

        <activity
            android:name=".applications.managedomainurls.ManageDomainUrlsActivity"
            android:configChanges="orientation|keyboardHidden|screenSize"
            android:windowSoftInputMode="adjustResize"
            android:exported="true">
            <intent-filter>
                <action android:name="android.settings.MANAGE_DOMAIN_URLS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.SINGLE_PANE" android:value="true"/>
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".security.SettingsScreenLockActivity"
            android:configChanges="orientation|keyboardHidden|screenSize"
            android:exported="true"
            android:windowSoftInputMode="adjustResize">
            <intent-filter>
                <action android:name="android.app.action.SET_NEW_PASSWORD" />
                <action android:name="android.car.settings.SCREEN_LOCK_ACTIVITY" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.SINGLE_PANE" android:value="true"/>
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".security.CheckLockActivity"
            android:configChanges="orientation|keyboardHidden|screenSize"
            android:exported="true"
            android:windowSoftInputMode="adjustResize">
            <intent-filter>
                <action android:name="android.app.action.CONFIRM_DEVICE_CREDENTIAL" />
                <action android:name="android.app.action.CONFIRM_FRP_CREDENTIAL" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.SINGLE_PANE" android:value="true"/>
        </activity>

        <activity
            android:name=".security.VerifyLockChangeActivity"
            android:configChanges="orientation|keyboardHidden|screenSize"
            android:exported="false"
            android:windowSoftInputMode="adjustResize">
            <meta-data android:name="com.android.car.settings.SINGLE_PANE" android:value="true"/>
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".security.ChooseLockPatternActivity"
            android:configChanges="orientation|keyboardHidden|screenSize|uiMode"
            android:windowSoftInputMode="adjustPan"
            android:noHistory="true"
            android:exported="false">
            <meta-data android:name="com.android.car.settings.SINGLE_PANE" android:value="true"/>
        </activity>

        <activity
            android:name=".security.ChooseLockPinActivity"
            android:configChanges="orientation|keyboardHidden|screenSize|uiMode"
            android:windowSoftInputMode="adjustPan"
            android:noHistory="true"
            android:exported="false">
            <meta-data android:name="com.android.car.settings.SINGLE_PANE" android:value="true"/>
        </activity>

        <activity
            android:name=".security.ChooseLockPasswordActivity"
            android:configChanges="orientation|keyboardHidden|screenSize|uiMode"
            android:windowSoftInputMode="adjustResize"
            android:noHistory="true"
            android:exported="false">
            <meta-data android:name="com.android.car.settings.SINGLE_PANE" android:value="true"/>
        </activity>

        <activity
            android:name=".profiles.ProfileSwitcherActivity"
            android:configChanges="orientation|keyboardHidden|screenSize"
            android:windowSoftInputMode="adjustResize"
            android:exported="true">
            <meta-data android:name="com.android.car.settings.SINGLE_PANE" android:value="true"/>
        </activity>

        <activity
            android:name=".security.CredentialStorageActivity"
            android:theme="@style/ActionDialogTheme"
            android:launchMode="singleTop"
            android:exported="true"
            android:configChanges="orientation|keyboardHidden|screenSize">
            <intent-filter android:priority="1">
                <action android:name="com.android.credentials.INSTALL" />
                <action android:name="com.android.credentials.RESET" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

        <activity
            android:name=".system.ThirdPartyLicensesActivity"
            android:label="@string/settings_license_activity_title"
            android:configChanges="orientation|keyboardHidden|screenSize"
            android:exported="true"
            android:windowSoftInputMode="adjustResize">
            <intent-filter>
                <action android:name="android.settings.THIRD_PARTY_LICENSE" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

        <activity
            android:name=".system.RegulatoryInfoDisplayActivity"
            android:label="@string/regulatory_labels"
            android:exported="true"
            android:enabled="@bool/config_show_regulatory_info">
            <intent-filter>
                <action android:name="android.settings.SHOW_REGULATORY_INFO" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

        <activity
            android:name=".datausage.DataWarningAndLimitActivity"
            android:configChanges="orientation|keyboardHidden|screenSize"
            android:windowSoftInputMode="adjustResize"
            android:exported="true">
            <meta-data android:name="distractionOptimized" android:value="true"/>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_DataWarningAndLimitActivity" />
        </activity>

        <activity
            android:name=".wifi.WifiRequestToggleActivity"
            android:theme="@style/ActionDialogTheme"
            android:excludeFromRecents="true"
            android:clearTaskOnLaunch="true"
            android:exported="true"
            android:launchMode="singleInstance"
            android:permission="android.permission.CHANGE_WIFI_STATE">
            <intent-filter>
                <action android:name="android.net.wifi.action.REQUEST_ENABLE" />
                <action android:name="android.net.wifi.action.REQUEST_DISABLE" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

        <!-- This is used internally for CTS tests and should not be used in generally. -->
        <activity android:name=".wifi.networkrequest.NetworkRequestDialogActivity"
                  android:excludeFromRecents="true"
                  android:exported="true"
                  android:launchMode="singleTop"
                  android:permission="android.permission.NETWORK_SETTINGS"
                  android:taskAffinity=".wifi.networkrequest.NetworkRequestDialogActivity"
                  android:theme="@style/ActionDialogTheme">
            <intent-filter>
                <action android:name="com.android.settings.wifi.action.NETWORK_REQUEST"/>
                <category android:name="android.intent.category.DEFAULT"/>
            </intent-filter>
        </activity>

        <!-- This logic is copied from phone.-->
        <!-- Ensures there's lightweight fallback activity when no other MAIN/HOME activity is present.-->
        <activity
            android:name=".FallbackHome"
            android:excludeFromRecents="true"
            android:label=""
            android:screenOrientation="nosensor"
            android:exported="true"
            android:theme="@style/FallbackHome"
            android:configChanges="keyboardHidden">
            <intent-filter android:priority="-900">
                <action android:name="android.intent.action.MAIN" />
                <category android:name="android.intent.category.HOME" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".enterprise.DeviceAdminAddActivity"
            android:exported="true">
            <meta-data android:name="com.android.car.settings.SINGLE_PANE" android:value="true"/>
            <meta-data android:name="distractionOptimized" android:value="true"/>
            <intent-filter>
                <action android:name="android.app.action.ADD_DEVICE_ADMIN" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

        <activity
            android:name=".enterprise.EnterprisePrivacySettingsActivity"
            android:exported="true">
            <meta-data android:name="com.android.car.settings.SINGLE_PANE" android:value="true"/>
            <meta-data android:name="distractionOptimized" android:value="true"/>
            <intent-filter>
                <action android:name="android.settings.ENTERPRISE_PRIVACY_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

        <activity android:name=".notifications.NotificationAccessConfirmationActivity"
            android:exported="false"
            android:taskAffinity="com.android.car.settings.notifications.NotificationAccessConfirmationActivity"
            android:theme="@style/ActionDialogTheme"
            />

        <activity android:name=".enterprise.ActionDisabledByAdminActivity"
                android:theme="@style/ActionDialogTheme"
                android:taskAffinity=".enterprise"
                android:excludeFromRecents="true"
                android:exported="true">
            <intent-filter android:priority="1">
                <action android:name="android.settings.SHOW_ADMIN_SUPPORT_DETAILS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$AccessibilityActivity"
            android:configChanges="orientation|keyboardHidden|screenSize"
            android:windowSoftInputMode="adjustResize"
            android:exported="true">
            <intent-filter>
                <action android:name="android.settings.ACCESSIBILITY_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_AccessibilitySettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".common.CarSettingActivities$CaptionsActivity"
            android:configChanges="orientation|keyboardHidden|screenSize"
            android:windowSoftInputMode="adjustPan"
            android:exported="true">
            <intent-filter>
                <action android:name="android.settings.CAPTIONING_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="com.android.car.settings.TOP_LEVEL_HEADER_KEY"
                       android:value="@string/hk_CaptionsSettingsActivity" />
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

        <activity
            android:name=".sound.AudioRouteSelectionActivity"
            android:theme="@style/AlertDialogTheme"
            android:permission="android.car.permission.CAR_CONTROL_AUDIO_SETTINGS"
            android:clearTaskOnLaunch="true"
            android:exported="true"
            android:launchMode="singleInstance"
            android:windowSoftInputMode="stateVisible|adjustResize"
            android:excludeFromRecents="true">
            <intent-filter>
                <action android:name="com.android.car.settings.AUDIO_ROUTE_SETTINGS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="distractionOptimized" android:value="true"/>
        </activity>

    <service android:name=".bluetooth.BluetoothPairingService" />

        <service android:name=".setupservice.InitialLockSetupService"
                 android:exported="true"
                 android:permission="com.android.car.settings.SET_INITIAL_LOCK"/>

        <receiver android:name=".bluetooth.BluetoothPairingRequest"
            android:exported="true">
            <intent-filter>
                <action android:name="android.bluetooth.device.action.PAIRING_REQUEST" />
            </intent-filter>
        </receiver>

        <!-- Exported for SystemUI to trigger -->
        <receiver android:name=".storage.StorageUnmountReceiver"
                  android:exported="true"
                  android:permission="android.permission.MOUNT_UNMOUNT_FILESYSTEMS" />

        <!-- FileProvider to share a generated license html file.
             Note that "com.android.settings.files" is set here as its authorities because a Uri
             permission grant should be allowed to share a file with an external browser but it is
             allowed only for Settings' authorities in ActivityManagerService.  -->
        <provider android:name="androidx.core.content.FileProvider"
                  android:authorities="com.android.settings.files"
                  android:grantUriPermissions="true"
                  android:exported="false">
            <meta-data android:name="android.support.FILE_PROVIDER_PATHS"
                       android:resource="@xml/file_paths" />
        </provider>

        <provider
            android:name=".search.CarSettingsSearchIndexablesProvider"
            android:authorities="com.android.car.settings"
            android:multiprocess="false"
            android:grantUriPermissions="true"
            android:permission="android.permission.READ_SEARCH_INDEXABLES"
            android:exported="true">
            <intent-filter>
                <action android:name="android.content.action.SEARCH_INDEXABLES_PROVIDER" />
            </intent-filter>
        </provider>

        <provider android:name=".qc.SettingsQCProvider"
                  android:authorities="com.android.car.settings.qc"
                  android:grantUriPermissions="true"
                  android:exported="true">
        </provider>

        <!-- For security purposes, only intents created by the CarSettings application should be
        able to call this receiver. Therefore, it should not be exported. -->
        <receiver
            android:name=".qc.SettingsQCBroadcastReceiver"
            android:exported="false">
        </receiver>

        <receiver
            android:name=".qc.DisabledQCToastBroadcastReceiver"
            android:exported="false">
        </receiver>

    </application>
</manifest>
